#ifndef ITER_H
#define ITER_H

typedef enum { I_User, I_Fixed, I_NTimes, I_FiftyFiftyRatio,
    I_EstimatedImprovement, I_StabilizedGroups, I_Last } I_TYPE;

typedef int (*I_StoppingFunction)(float, int, float*);

typedef struct {
    I_TYPE Type;
    float* Values;
    int ValuesAllocated;
    int Count;
    int MinimumIterations;
    float Limit;
    I_StoppingFunction Func;
} Iterations;

Iterations* itNew(I_TYPE T, int MinIterations, float Limit,
    I_StoppingFunction F);
void itReset(Iterations* I);
void itDelete(Iterations* I);
int itStop(Iterations* I, float Value, int NumberOfGroups);

#endif
