#ifndef OPERATNS_H
#define OPERATNS_H

#include "cb.h"
#include "DistCrit/criteria.h"

typedef struct {
    int Number;
    long Key;
} PermutationData;

typedef struct {
    float BestError;
    float RemoveP, AddP;
    int MinClusters, MaxClusters;
    int MaxChange;
    float Alpha;
    float Adaptivity;
    float Gauss;
    int LastSelected;
    int CountChangeMethod;
    int SwapMethod;
    PermutationData* Permutation;
    CODEBOOK Store;
} Operations;

enum { OPS_SEL_NONE, OPS_SEL_REMOVE, OPS_SEL_ADD, OPS_SEL_SWAP };
enum { OPS_CCM_RANDOM, OPS_CCM_SIZE, OPS_CCM_ITERATIVE };

Operations* opsNew(float InitialError, int MinClust, int MaxClust,
    int MaxChg, float ProbDistrPower, float Adaptivity, float GaussStdDev,
    float GroupChangeProb, int CountChangeMethod, int SwapMethod,
    TRAININGSET* TS);
void opsDelete(Operations* Ops);

int opsSelect(Operations* Ops, int CurrentSize);
void opsUpdate(Operations* Ops, float Error);

void opsPerform(Operations* Ops,
    TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA,
    CriterionInfo* CI, int* Changes, int* Freq2IndexMap);

#endif

